Widget.onPropertyChange = function (propname, newvalue, oldvalue) {
    var _a = Widget.props, start_icon = _a.start_icon, end_icon = _a.end_icon, show_icons = _a.show_icons, icon_actions = _a.icon_actions, datavalue = _a.value, show_labels = _a.show_labels;
    var widgetMap = Widget.Widgets;
    var showIconsBool = convertToBoolean(show_icons);
    var showLabelsBool = convertToBoolean(show_labels);
    var iconActionsBool = convertToBoolean(icon_actions);
    switch (propname) {
        case "prop-show_icons":
            toggleIconsVisibility(showIconsBool, start_icon, end_icon, iconActionsBool, widgetMap);
            break;
        case "prop-start_icon":
            updateStartIconVisibility(iconActionsBool, widgetMap);
            break;
        case "prop-end_icon":
            updateEndIconVisibility(iconActionsBool, widgetMap);
            break;
        case "prop-value":
            updateSliderValue(datavalue, widgetMap);
            break;
        case "prop-show_labels":
            toggleLabelVisibilty(showLabelsBool, widgetMap);
            break;
        case "prop-max_value":
        case "prop-min_value":
            updateSliderValue(datavalue, widgetMap);
            break;
    }
};
Widget.onReady = function () {
    var _a = Widget.props, start_icon = _a.start_icon, end_icon = _a.end_icon, show_icons = _a.show_icons, icon_actions = _a.icon_actions, datavalue = _a.value, show_labels = _a.show_labels;
    var widgetMap = Widget.Widgets;
    var showIconsBool = convertToBoolean(show_icons);
    var showLabelsBool = convertToBoolean(show_labels);
    var iconActionsBool = convertToBoolean(icon_actions);
    toggleIconsVisibility(showIconsBool, start_icon, end_icon, iconActionsBool, widgetMap);
    toggleLabelVisibilty(showLabelsBool, widgetMap);
    updateSliderValue(datavalue, widgetMap);
    activeSliderElement(widgetMap);
};
function convertToBoolean(value) {
    return value === true || value === "true";
}
function updateStartIconVisibility(iconActionsBool, widgetMap) {
    var decrementButton = widgetMap.decrementButton;
    decrementButton.show = true;
    decrementButton.nativeElement.style.pointerEvents = iconActionsBool ?
        "auto" :
        "none";
}
function updateEndIconVisibility(iconActionsBool, widgetMap) {
    var incrementButton = widgetMap.incrementButton;
    incrementButton.show = true;
    incrementButton.nativeElement.style.pointerEvents = iconActionsBool ?
        "auto" :
        "none";
}
function updateSliderValue(datavalue, widgetMap) {
    var slider1 = widgetMap.slider1;
    if (datavalue !== undefined) {
        slider1.datavalue = Number(datavalue);
    }
    slider1.nativeElement.style.setProperty("--end", (100 - getSliderPercentage(slider1.datavalue)) + '%');
}
function toggleIconsVisibility(showIconsBool, startIcon, endIcon, iconActionsBool, widgetMap) {
    var decrementButton = widgetMap.decrementButton, incrementButton = widgetMap.incrementButton;
    if (showIconsBool) {
        if (startIcon)
            updateStartIconVisibility(iconActionsBool, widgetMap);
        if (endIcon)
            updateEndIconVisibility(iconActionsBool, widgetMap);
    }
    else {
        if (startIcon)
            decrementButton.show = false;
        if (endIcon)
            incrementButton.show = false;
    }
}
function toggleLabelVisibilty(showLabelsBool, widgetMap) {
    if (showLabelsBool) {
        widgetMap.slider1.nativeElement.classList.remove("hide-labels");
    }
    else {
        widgetMap.slider1.nativeElement.classList.add("hide-labels");
    }
}
function activeSliderElement(widgetMap) {
    var activeSlider = widgetMap.slider1.nativeElement; // Get the slider element
    if (activeSlider) {
        // Create a new div element
        var newDiv = document.createElement("p");
        newDiv.className = "active-slider"; // Set a class for styling
        // Append the new element to slider container
        activeSlider.appendChild(newDiv);
    }
}
/*
 * Convert slider value to percentage based on min and max
 */
function getSliderPercentage(value) {
    var minValue = parseInt(Widget.props.min_value, 10);
    var maxValue = parseInt(Widget.props.max_value, 10);
    return ((value - minValue) / (maxValue - minValue)) * 100;
}
Widget.slider1Change = function ($event, widget, newVal, oldVal) {
    var sliderValue = 100 - getSliderPercentage(newVal) + "%";
    widget.nativeElement.style.setProperty("--end", sliderValue);
};
function moveSlider(direction, widgetMap) {
    var slider1 = widgetMap.slider1;
    var newValue = Number(slider1.datavalue) + direction;
    newValue = Math.max(Math.min(newValue, slider1.maxvalue), slider1.minvalue);
    slider1.datavalue = newValue;
    Widget.slider1Change(null, slider1, newValue, slider1.datavalue);
}
Widget.decrementButtonClick = function ($event, widget) {
    moveSlider(-1, Widget.Widgets);
};
Widget.incrementButtonClick = function ($event, widget) {
    moveSlider(1, Widget.Widgets);
};
